ADD_CFLAGS = -O
#ADD_CFLAGS = -g

INC	= -I$(HDFINC) -I$(HDF5INC) -I$(HDFEOS_INC) -I$(HDFEOS5_INC)

#LIB	= -L$(HDFLIB) -lmfhdf -ldf -lz

LIB	= -L$(HDFLIB) -L$(HDFEOS_LIB) -L$(HDF5LIB) -L$(HDFEOS5_LIB) -lhdfeos -lhe5_hdfeos \
          -lGctp -lmfhdf -ldf -lz -ljpeg -lm -lsz -lhdf5_hl -lhdf5
	  
TARGET  = cp_proj_param

OBJ    = cp_proj_param.o meta.o alloc_mem.o sds_rw.o str_op.o main_util.o eos_sds_rw.o tile_bound_info.o

INC_FILES = qa_tool.h sds_rw.h alloc_mem.h str_op.h main_util.h meta.h eos_sds_rw.h tile_bound_info.h

all: $(TARGET)

$(OBJ):	$(INC_FILES)

$(TARGET): $(OBJ) $(INC_FILES)
	$(CC) $(ADD_CFLAGS) -o $(TARGET) $(OBJ) $(LIB)
clean:
	rm -f *.o core

#
# Rules
#
.c.o:
	$(CC) $(ADD_CFLAGS) $(INC) -c $< -o $@
